<?php

class guestbook extends serializeableObject {

   var $id     = "default";
   var $page   = 0;
   var $target = "";
   var $next_action = "show";

/*********************************************************************************************/

   function guestbook($ARGS) {
      @session_start();
      global $YANA;

      # <... Typsicherheit herstellen
      settype($ARGS, "array");
      # ENDE ...>

      if (!empty($ARGS['id']))                        $this->id          = strtolower($ARGS['id']);
      if (!empty($ARGS['page']) && $ARGS['page']>0)   $this->page        = $ARGS['page'];
      if (!empty($ARGS['target']))                    $this->target      = $ARGS['target'];
      if (!empty($ARGS['action']))                    $this->next_action = $ARGS['action'];

      # Initialisiere
   }

/*********************************************************************************************/

    function getBookEntries(/* boolean */ $extend) {
      settype($extend, "boolean");
      global $YANA;

        # <... neue Gstebcher nicht anzeigen, falls Auto-Option deaktiviert ist
        if ($this->isOffspring() && !$YANA->getVar("PROFILE.AUTO")) {
          $YANA->message("error", "4041", "show");
        }
        # ...>

      $REF = array();
      if (!$extend) {
          $REF['BESCHREIBUNG'] = $YANA->getVar("LANGUAGE.DESCR_SHOW");
          $YANA->setVar("ACTION", "show");
      } else {
          $REF['BESCHREIBUNG'] = $YANA->getVar("LANGUAGE.DESCR_DETAILS");
          $YANA->setVar("ACTION", "details");
      }

      $profiles_installed = false;
      $profiles_installed = $YANA->getVar("INSTALLED_PLUGINS.USER_PROFILES");

      if ($this->id == 'default') {
        $myGB = $YANA->plugins->get("guestbook", "default_gbuch");
      } else {
        $myGB = $YANA->plugins->get("guestbook", "gbuch");
      }

      $myGB->read();
      if (!$myGB->exists()) {
        $myGB = $YANA->plugins->get("guestbook", "default_gbuch");
        $myGB->read();
      }
      $last_page = $myGB->length();

      $entPerPage          = $YANA->getVar("PROFILE.GUESTBOOK.ENTPERPAGE");
      $kommentar_title     = $YANA->getVar("LANGUAGE.TITLE_KOMMENTAR");
      $kommentar_einfuegen = $YANA->getVar("LANGUAGE.KOMMENTAR");
      $kommentar_ersetzen  = $YANA->getVar("LANGUAGE.TITLE_KOMMENTAR_ERSETZEN");
      $loeschen_title      = $YANA->getVar("LANGUAGE.TITLE_LOESCHEN");
      $loeschen_text       = $YANA->getVar("LANGUAGE.LOESCHEN");

      settype($entPerPage, "integer");
      if (empty($entPerPage) || $entPerPage < 1) {
        $entPerPage = 10;
      }

      $liste = array();
      if ($last_page > ($entPerPage*2)) {
        $dots = false;
        for($k=0;$k<ceil($last_page/$entPerPage);$k++) {
          $it   = count($liste);
          $first = ($k*$entPerPage);
          $last  = ((($k+1)*$entPerPage < $last_page) ? ($k+1)*$entPerPage : $last_page);
          if ($last_page > 10 * $entPerPage && $k > 1 && $k < ceil($last_page/$entPerPage) - 2 && !($first > $this->page-$entPerPage-1 && $last < $this->page+1+(2*$entPerPage))) {
            if (!$dots) {
              $dots = true;
              $liste[$it]['TOO_MANY'] = true;
            }
          } else {
            $liste[$it]['FIRST'] = ($first+1);
            $liste[$it]['LAST']  = $last;
            if ($first > $this->page-1 && $last < $this->page+$entPerPage+1) $dots = false;
          }
        }
      }
      $YANA->setVar('LIST_OF_ENTRIES', $liste);
      $YANA->setVar('ENTRIES_PER_PAGE', $entPerPage);
      $YANA->setVar('FIRST_PAGE', $this->page+1);
      $YANA->setVar('LAST_PAGE', $myGB->length());
      $YANA->setVar('OFFSET_PAGE', ($this->page+$entPerPage > $last_page) ? $last_page : $this->page+$entPerPage);

      for ($j=$this->page;$j<$last_page && $j<($this->page+$entPerPage); $j++) {

        $REF['ROWS'][$j] = $myGB->get($j);
        $REF['ROWS'][$j]['IS_REGISTERED'] = $profiles_installed && !empty($REF['ROWS'][$j]['IS_REGISTERED']);
        $REF['ROWS'][$j]['GUESTBOOK_ID']  = $j;

        # <... Prfe Werte auf Gltigkeit
/*     	if (empty($REF['ROWS'][$j]['GUESTBOOK_COMMENT'])) {
          $REF['ROWS'][$j]['GUESTBOOK_COMMENT'] = '<a title="'.$kommentar_title.'" target="_self" href="'.$this->genLink("comment",$j,'*').'">'.$kommentar_einfuegen.'</a>';
        } else {
          $REF['ROWS'][$j]['GUESTBOOK_COMMENT'].= '<div><a title="'.$kommentar_title.'" target="_self" href="'.$this->genLink("comment",$j,'*').'">'.$kommentar_ersetzen.'</a></div>';
        } */
    	if (!isset($REF['ROWS'][$j]['LOESCHEN'])) {
          $REF['ROWS'][$j]['LOESCHEN'] = '<a title="'.$loeschen_title.'" target="_self" href="'.$this->genLink("delete",$j,'*').'">'.$loeschen_text.'</a>';
        }
        # Prfe Werte auf Gltigkeit ...>
      } # end for

      $REF["BESCHREIBUNG"] = layout::iterativeFill($REF["BESCHREIBUNG"],$REF);

      $YANA->registry->merge("", $REF);
    }

    function get_new() {
      global $YANA;

      $YANA->setVar("SECURITY_IMAGE_INDEX", rand(1,9));

      $REF = array();
      $REF['BESCHREIBUNG'] = $YANA->getVar("LANGUAGE.DESCR_NEW");
      $REF['FORM_PARAMS']  = $this->genFormParams("add",$this->target);
      $YANA->registry->merge("", $REF);
    }

    function get_comment() {
      global $YANA;
      if (isset($this->target)) settype($this->target, "integer");

      if (isset($this->target) && $this->target>-1) {

          if ($this->id == 'default') {
            $myGB = $YANA->plugins->get("guestbook", "default_gbuch");
          } else {
            $myGB = $YANA->plugins->get("guestbook", "gbuch");
          }
    
          $myGB->read();
          $ROW = $myGB->get($this->target, 1);

          $YANA->registry->setVar("BESCHREIBUNG", $YANA->getVar("LANGUAGE.DESCR_KOMMENTAR"));
          $YANA->registry->setVar("GUESTBOOK_COMMENT", $ROW["GUESTBOOK_COMMENT"]);

      } else {
        $YANA->message("error", "UNGUELTIGE_EINGABE", "show");
      }

    }

    function get_delete() {
      global $YANA;
      if (isset($this->target))  settype($this->target, "integer");

      if (isset($this->target) && $this->target>-1) {

          $REF = array();
          $REF['BESCHREIBUNG'] = $YANA->getVar("LANGUAGE.DESCR_LOESCHEN");
          $REF['FORM_PARAMS']  = $this->genFormParams("deleteentry",$this->target);
          $YANA->registry->merge("", $REF);

      } else {
        $YANA->message("error", "UNGUELTIGE_EINGABE", "show");
      }

    }

/*********************************************************************************************/

    function set_delete() {
      global $YANA;
      if (isset($this->target)) { settype($this->target, "integer"); };

      if (isset($this->target) && $this->target > -1) {

          if ($this->id == 'default') {
            $myGB = $YANA->plugins->get("guestbook", "default_gbuch");
          } else {
            $myGB = $YANA->plugins->get("guestbook", "gbuch");
          }
          $myGB->read();

          $entry = $myGB->get($this->target);
          if (!$myGB->remove($this->target)) { $YANA->message("error", "500", "delete"); };
          if (!$myGB->failSafeWrite())       { $YANA->message("error", "500", "delete"); };
          $YANA->report( new log('Removing entry from file:',makeConfig($entry)));
          return true;

      } else {
        return false;
      }
    }                             	

    function set_comment($new_comment) {
      global $YANA;
      if (isset($this->target)) { settype($this->target, "integer"); };

      if (isset($this->target) && $this->target > -1) {

          if ($this->id == 'default') {
            $myGB = $YANA->plugins->get("guestbook", "default_gbuch");
          } else {
            $myGB = $YANA->plugins->get("guestbook", "gbuch");
          }

          $myGB->read();

          $REF = $myGB->getRawData($this->target);
          $REF['GUESTBOOK_COMMENT'] = $new_comment;
          $myGB->replace($this->target,$REF);

          if (!$myGB->failSafeWrite()) {
            $YANA->message("error", "500", "comment");
          } else {
            $YANA->message("OK", "200", "show");
          }

      } else {
        $YANA->message("error", "UNGUELTIGE_EINGABE", "show");
      }

    }

    function set_new($INPUT) {
      global $YANA;

      # <... Schutz gegen Spam
      if ($YANA->getVar("PROFILE.GUESTBOOK.SPAMPROTECT") === true && !$YANA->handle("security_check_image", $INPUT))
      $YANA->message("alert", "ungueltige_eingabe", "new");
      # ...>

      # <... neue Gstebcher nicht anzeigen, falls Auto-Option deaktiviert ist
      if ($this->isOffspring() && !$YANA->getVar("PROFILE.AUTO")) { $YANA->message("error", "4041", "show"); }
      # ...>

      # <... Protection
      $INPUT['form_pflichtfelder'] = (isset($INPUT['form_pflichtfelder'])) ? explode(" ", strtolower($INPUT['form_pflichtfelder'])) : array();
      for ($i=0;$i<count($INPUT['form_pflichtfelder']);$i++) if ($INPUT[$INPUT['form_pflichtfelder'][$i]]=="") $YANA->message("alert", "FEHLER", "new");

      $myFlood = $YANA->plugins->get("guestbook", "flood");
      $myFlood->setMax($YANA->getVar("PROFILE.GUESTBOOK.FLOODING"));
      if ($myFlood->isBlocked()) { $YANA->message("alert", "FLOODING", "new"); };

      unset($INPUT['form_pflichtfelder']);
      unset($INPUT['id']);
      unset($INPUT['page']);
      unset($INPUT['action']);
      unset($INPUT['target']);
      unset($INPUT['security_image_index']);
      unset($INPUT['security_image']);
      unset($INPUT[strtolower(session_name())]);
      # ...>      

      if (strcasecmp($YANA->getVar("SESSION_USER_ID"), $INPUT['guestbook_name']) == 0) {
       $INPUT['GUESTBOOK_IS_REGISTERED'] = 1;
      } else {
       $INPUT['GUESTBOOK_IS_REGISTERED'] = 0;
      }
      $INPUT['GUESTBOOK_DATE']           = time();
      $INPUT['GUESTBOOK_IP']             = $_SERVER['REMOTE_ADDR'];

      if ($this->id == 'default') {
        $myGB = $YANA->plugins->get("guestbook", "default_gbuch");
      } else {
        $myGB = $YANA->plugins->get("guestbook", "gbuch");
      }

      if (!$myGB->read()) {
        if (!$myGB->create()) {
          return false;
        }
      }

      # <... Flooding Protection
        $temp1 = $myGB->get(0); unset($temp1['GUESTBOOK_DATE']);
        $myGB->insert($INPUT);
        $temp2 = $myGB->get(0); unset($temp2['GUESTBOOK_DATE']);
        if($temp1 == $temp2) { $YANA->message("alert", "NOSPAM", "new"); }
        if($myFlood->getMax()>0)  { $myFlood->set(); };
      # ...>

      if ($myGB->failSafeWrite()) {
         # <... Send Mail
          if (trim($INPUT['guestbook_mail'])!= "" && $YANA->getVar("PROFILE.GUESTBOOK.SENDMAIL")) {
            $this->send_mail($INPUT['guestbook_mail'],$YANA->skin->getFile("danke_mail"),$INPUT);
          }
          if ($YANA->getVar("PROFILE.GUESTBOOK.MAIL") && $YANA->getVar("PROFILE.GUESTBOOK.NOTIFICATION")) {
            $this->send_mail($YANA->getVar("PROFILE.GUESTBOOK.MAIL"),$YANA->skin->getFile("benachrichtigung_mail"),$INPUT);
          }
          # ...>
        return true;
      } else {
        return false;
      }
    }


/*********************************************************************************************/

   function isOffspring() {
      global $YANA;
      if ($this->id == "default") return false;
      $file = $YANA->plugins->get('guestbook', 'gbuch');

      return (!$file->exists() && $this->id != 'gbuch');
   }

   function genLink($action, $target, $page) {
      settype($action, "string");
      settype($target, "string");
      settype($page, "string");
      global $YANA;

      if ($action=="*") $action = $this->next_action;
      if ($target=="*") $target = $this->target;
      if ($page=="*")   $page   = $this->page;
      return $YANA->getVar("PHP_SELF")."?action=".$action."&amp;page=".$page."&amp;id=".$this->id."&amp;target=".$target.( (session_id()) ? "&amp;".session_name()."=".session_id() : '' );
   }

   function genFormParams($action,$target) {
      settype($action, "string");
      settype($target, "string");
      global $YANA;

      $text = '<input type="hidden" name="target" value="'.$target.'">'.
              '<input type="hidden" name="id" value="'.$this->id.'">'.
              '<input type="hidden" name="action" value="'.$action.'">'.
              ( (session_id()) ? '<input type="hidden" name="'.session_name().'" value="'.session_id().'">' : '' );
      return $text;
   }

   function send_mail($empfaenger,$template,$INPUT) {
      global $YANA;
      $INPUT = changeCaseArray($INPUT);
      $heute                = getdate();
      $mail                 = new mailer($template);
      $mail->subject        = $YANA->getVar("LANGUAGE.MAIL_SUBJECT")."<br>\n";
      $mail->insert("*", $INPUT);
      $mail->insert("*", $YANA->getVar("*"));
      $mail->insert('DATUM', $heute['mday'] . '.' . $heute['mon'] . '.' . $heute['year']);
      $mail->send($empfaenger);
   }

} // class

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
