<?php


/* public */ class plugin_guestbook_db extends plugin {

  /* private bufferedDbStream */ var $database;
  /* private readonly String */ var $ACTION_SHOW          = "guestbook_db_read_read_guestbook";
  /* private readonly String */ var $ACTION_DETAILS       = "guestbook_db_read_read_seperated_guestbook";
  /* private readonly String */ var $ACTION_NEW           = "guestbook_db_default_new_guestbook";
  /* private readonly String */ var $ACTION_NEW_WRITE     = "guestbook_db_write_new_guestbook";
  /* private readonly String */ var $ACTION_DELETE        = "guestbook_db_write_delete_guestbook";
  /* private readonly String */ var $ACTION_EDIT          = "guestbook_db_read_edit_guestbook";
  /* private readonly String */ var $ACTION_EDIT_WRITE    = "guestbook_db_write_edit_guestbook";
  /* private readonly String */ var $ACTION_COMMENT       = "guestbook_db_default_comment_guestbook";
  /* private readonly String */ var $ACTION_COMMENT_WRITE = "guestbook_db_write_comment_guestbook";
  /* private readonly String */ var $ACTION_INSTALL       = "guestbook_db_primary_install";

  /* constructor */ function plugin_guestbook_db($name) {
      settype($name,"string");
      global $YANA;

      $this->name = $name;
      $this->database = $YANA->plugins->get($this->name,"DATABASE");
      
      /* Plugin-specific addities */
      
      $YANA->setVar("ACTION_SHOW"         , $this->ACTION_SHOW);
      $YANA->setVar("ACTION_DETAILS"      , $this->ACTION_DETAILS);
      $YANA->setVar("ACTION_NEW"          , $this->ACTION_NEW);
      $YANA->setVar("ACTION_NEW_WRITE"    , $this->ACTION_NEW_WRITE);
      $YANA->setVar("ACTION_DELETE"       , $this->ACTION_DELETE);
      $YANA->setVar("ACTION_EDIT"         , $this->ACTION_EDIT);
      $YANA->setVar("ACTION_EDIT_WRITE"   , $this->ACTION_EDIT_WRITE);
      $YANA->setVar("ACTION_COMMENT"      , $this->ACTION_COMMENT);
      $YANA->setVar("ACTION_COMMENT_WRITE", $this->ACTION_COMMENT_WRITE);
      $YANA->setVar("ACTION_INSTALL"      , $this->ACTION_INSTALL);
      $dir = $YANA->getVar("PROFILE.SMILEYDIR");
      if (is_dir($dir)) loadSmilies($dir);      
  }

  /* public void */ function _default(/* String */ $event, /* Hashtable */ $ARGS) {

    # check input data
    settype($event, "string");
    settype($ARGS, "array");
    $event = strtolower($event);

    global $YANA;

     switch ($event) {

# BEGIN auto-generated Event-handlers


         /* Type: read, Permission: 75, Templates:  GUESTBOOK_DB_EDIT_GUESTBOOK */
         case $this->ACTION_EDIT:
           $YANA->setVar("BESCHREIBUNG", $YANA->getVar("LANGUAGE.DESCR_SHOW"));
           $DB_SRC = changeCaseArray($this->database->source);
           $YANA->setVar('DATABASE', $DB_SRC);
           /* Create search request */
           $url_where = "";
           if (empty($ARGS['where'])) {

             $ARGS['where'] = "";
             foreach ($DB_SRC['TABLES']['GUESTBOOK']['CONTENT'] as $NAME => $CURRENT)
             {
               $NAME = strtolower($NAME);
               if (!empty($ARGS["search_".$NAME]))
               {
                 if (!empty($ARGS['where']))
                 {
                   $ARGS['where'] .= ',';
                   $url_where     .= ',';
                 }
                 $ARGS['where']   .= $NAME.'='.htmlentities($ARGS["search_".$NAME]);
                 $url_where       .= $NAME.'='.urlencode(htmlentities($ARGS["search_".$NAME]));
               }
             }

           } else {
             $url_where = $ARGS['where'];
           }
           /* commit request */
           $YANA->setVar('DATABASE', changeCaseArray($this->database->source));
           $YANA->setVar('WHERE', $url_where);
           $YANA->setVar('ROWS', $this->_get_table($ARGS, "guestbook"));
           return true;
         break;


         /* Type: write, Permission: 75, Templates: MESSAGE  */
         case $this->ACTION_EDIT_WRITE:
           /* convert raw form data into arrays */
           $ENTRIES = array();
           foreach($ARGS as $a => $b)
           {
             if (preg_match("/^guestbook\/([^\/]+)\/(.+)$/i", $a, $m) && !empty($b))
             {
               /* before doing anything, check if entry exists */
               if (!$this->database->exists("guestbook.".strtolower($m[1])))
               {
                 $YANA->report(new alert("ungueltige_eingabe"));
                 $YANA->report(new log("SQL-ERROR: table guestbook.".strtolower($m[1])." does not exist!"));
                 return false;
               } else {
                 $ENTRIES[strtolower($m[1])][strtolower($m[2])] = $b;
               }
             }
           }
           /* now update the entries */
           foreach($ENTRIES as $primary_key => $entry)
           {
             /* change entry only if it has been marked */
             if (!empty($ARGS["marker/$primary_key"]))
             {
               /* update the row */
               $this->database->insert("guestbook.$primary_key", $entry);
             }
           }
           /* don't forget to save your recent changes ;-) */
           if ($this->database->write()) {
             return true;
           } else {
             return false;
           }
         break;


         /* Type: write, Permission: 75, Templates: MESSAGE  */
         case $this->ACTION_DELETE:
           /* find any previously marked entries and mark them for removal */
           foreach($ARGS as $a => $b)
           {
             if (preg_match("/^MARKER\//i", $a) && !empty($b))
             {
               /* before deleting, check if entry exists */
               if (!$this->database->exists("guestbook.".strtolower($b)))
               {
                 $YANA->report(new alert('ungueltige_eingabe', 'The selected entry '.strtolower($b).' does not exist!'));
                 return false;
               } else {
                 $result = $this->database->get("guestbook.".strtolower($b));
                 $YANA->report(new log('Removing entry from database:', preg_replace('/\s/', ' ', makeConfig($result))));
               }
               $this->database->remove("guestbook.".strtolower($b));
             }
           }
           /* now delete those entries */
           if ($this->database->write()) {
             return true;
           } else {
             return false;
           }
         break;


         /* Type: default, Permission: 0, Templates:  GUESTBOOK_DB_NEW_GUESTBOOK */
         case $this->ACTION_NEW:
           $this->_securityCheck();
           $YANA->setVar("SECURITY_IMAGE_INDEX", rand(1,9));
           $YANA->setVar("BESCHREIBUNG", $YANA->getVar("LANGUAGE.DESCR_NEW"));
           return true;
         break;


         /* Type: write, Permission: 0, Templates: MESSAGE  */
         case $this->ACTION_NEW_WRITE:
           $this->_securityCheck();

           /* avoid spamming */
           if ($YANA->getVar("PROFILE.GUESTBOOK.SPAMPROTECT") === true && !$YANA->handle("security_check_image", $ARGS)) {
             $YANA->report(new alert('ungueltige_eingabe', 'Security check failed!'));
             $YANA->report(new log('Possible spamming attempt detected. Security check failed.'));
             return false;
           }

           /* get values from form fields to create new entry */
           $NEW_ENTRY = array();
           $profile_id = $YANA->getVar("PROFILE.GUESTBOOK.PROFILE");
           if (!empty($profile_id))                  $NEW_ENTRY['profile_id']          = $profile_id;
           else if (!empty($ARGS['id']))             $NEW_ENTRY['profile_id']          = $ARGS['id'];
           else                                      $NEW_ENTRY['profile_id']          = 'default';
           if (!empty($ARGS['guestbook_ip']))        $NEW_ENTRY['guestbook_ip']        = $ARGS['guestbook_ip'];
           if (!empty($ARGS['guestbook_name']))      $NEW_ENTRY['guestbook_name']      = $ARGS['guestbook_name'];
           if (!empty($ARGS['guestbook_message']))   $NEW_ENTRY['guestbook_message']   = $ARGS['guestbook_message'];
           if (!empty($ARGS['guestbook_mail']))      $NEW_ENTRY['guestbook_mail']      = $ARGS['guestbook_mail'];
           if (!empty($ARGS['guestbook_hometown']))  $NEW_ENTRY['guestbook_hometown']  = $ARGS['guestbook_hometown'];
           if (!empty($ARGS['guestbook_homepage']))  $NEW_ENTRY['guestbook_homepage']  = $ARGS['guestbook_homepage'];
           if (!empty($ARGS['guestbook_messenger'])) $NEW_ENTRY['guestbook_messenger'] = $ARGS['guestbook_messenger'];
           if (!empty($ARGS['guestbook_msgtyp']))    $NEW_ENTRY['guestbook_msgtyp']    = $ARGS['guestbook_msgtyp'];
           if (!empty($ARGS['guestbook_opinion']))   $NEW_ENTRY['guestbook_opinion']   = $ARGS['guestbook_opinion'];

           foreach ($NEW_ENTRY as $key => $val) {
             $val = trim($val);
             $val = preg_replace("/^(.{2000}\S*).*/", "\\1", $val);
             $val = preg_replace("/^(.{2100}).*/", "\\1", $val);
             $val = preg_replace("/\[\/\S+\]/U", "\\0 ", $val);
             $val = preg_replace("/\[[^\s\/]+\]/U", " \\0", $val);
             $val = preg_replace("/\:\S+\:/U", " \\0 ", $val);
             $val = preg_replace("/(\S{80})(\S)/", "\\1[wbr]\\2", $val);
             $val = preg_replace("/\[wbr\]\[wbr\]/", "[wbr]", $val);
             $val = toHtmlEntities(stripcslashes(trim($val)));
             $NEW_ENTRY[$key] = $val;
           }

           /* mark registered users */
           if (strcasecmp($YANA->getVar("SESSION_USER_ID"), $ARGS['guestbook_name']) == 0)
           $NEW_ENTRY['guestbook_is_registered'] = 1;

           /* avoid flooding */
           $myFlood = $YANA->plugins->get($this->name, "flood");
           $myFlood->setMax($YANA->getVar("PROFILE.GUESTBOOK.FLOODING"));
           if ($myFlood->isBlocked()) {
             $YANA->report(new log('Possibly flooding attempt detected. User request rejected.'));
             $YANA->report(new alert('flooding'));
             return false;
           }
           $recent_entry = $this->database->get("guestbook.?.guestbook_message", "", "order by guestbook_date desc", 0, 1);
           if(!empty($NEW_ENTRY['guestbook_message']) && $recent_entry == $NEW_ENTRY['guestbook_message']) {
             $YANA->report(new alert('nospam'));
             return false;
           }
           elseif($myFlood->getMax()>0)
           $myFlood->set();

           /* insert new entry into table */
           if (!$this->database->insert('guestbook.*',$NEW_ENTRY))
           {
             $YANA->report(new log('Failed to insert entry.', preg_replace('/\s/', ' ', makeConfig($NEW_ENTRY)) ));
             $YANA->report(new alert('ungueltige_eingabe'));
             return false;
           }
           elseif (!$this->database->write())
           {
             $YANA->report(new log('Unable to submit entry.', preg_replace('/\s/', ' ', makeConfig($NEW_ENTRY)) ));
             return false;
           }
           else
           {
             # <... Send Mail
             if (!empty($NEW_ENTRY['guestbook_mail']) && $YANA->getVar("PROFILE.GUESTBOOK.SENDMAIL"))
             $this->_send_mail($NEW_ENTRY['guestbook_mail'],$YANA->skin->getFile("danke_mail"),$ARGS);
             if ($YANA->getVar("PROFILE.GUESTBOOK.MAIL") && $YANA->getVar("PROFILE.GUESTBOOK.NOTIFICATION"))
             $this->_send_mail($YANA->getVar("PROFILE.GUESTBOOK.MAIL"),$YANA->skin->getFile("benachrichtigung_mail"),$ARGS);
             # ...>
             return true;
           }
         break;

         /* Type: read, Permission: 0, Templates:  GUESTBOOK_DB_READ_GUESTBOOK */
         case $this->ACTION_SHOW:
           $this->_securityCheck();
           $ARGS['sort']  = "guestbook_date";
           $ARGS['desc']  = true;
           $profile_id    = $YANA->getVar("PROFILE.GUESTBOOK.PROFILE");
           if (empty($profile_id)) $profile_id = ( (!empty($ARGS['id'])) ? $ARGS['id'] : 'default');
           $ARGS['where'] = "profile_id=$profile_id";
           $YANA->setVar("BESCHREIBUNG", $YANA->getVar("LANGUAGE.DESCR_SHOW"));
           $YANA->setVar('DATABASE', changeCaseArray($this->database->source));
           $YANA->setVar('ROWS', $this->_get_table($ARGS, "guestbook"));
           return true;
         break;


         /* Type: read, Permission: 0, Templates:  GUESTBOOK_DB_READ_SEPERATED_GUESTBOOK */
         case $this->ACTION_DETAILS:
           $this->_securityCheck();
           $ARGS['sort']  = "guestbook_date";
           $ARGS['desc']  = true;
           $profile_id    = $YANA->getVar("PROFILE.GUESTBOOK.PROFILE");
           if (empty($profile_id)) $profile_id = ( (!empty($ARGS['id'])) ? $ARGS['id'] : 'default');
           $ARGS['where'] = "profile_id=$profile_id";
           $YANA->setVar("BESCHREIBUNG", $YANA->getVar("LANGUAGE.DESCR_DETAILS"));
           $YANA->setVar('DATABASE', changeCaseArray($this->database->source));
           $YANA->setVar('ROWS', $this->_get_table($ARGS, "guestbook"));
         break;


         /* Type: primary, Permission: 100, Templates: MESSAGE  */
         case $this->ACTION_INSTALL:
          $file = $YANA->plugins->get($this->name,"SQL");
          if (!$this->database->create($file->getFilename())) {
            $YANA->report(new log('SQL installation fault.'));
            return false;
          } else {
            return true;
          }
         break;

         /* Type: default, Permission: 30, Templates: GUESTBOOK_DB_DEFAULT_COMMENT_GUESTBOOK  */
         case $this->ACTION_COMMENT:
           $guestbook_comment = $this->database->get('guestbook.'.strtolower($ARGS['target']).'.guestbook_comment');
           if (!empty($guestbook_comment))
           {
             $YANA->setVar('GUESTBOOK_COMMENT', $guestbook_comment);
           }
           return true;
         break;


         /* Type: write, Permission: 30, Templates: MESSAGE  */
         case $this->ACTION_COMMENT_WRITE:
          if (!$this->database->insert('guestbook.'.$ARGS['target'].'.guestbook_comment', $ARGS['guestbook_comment']) ||
              !$this->database->write()) {
            $YANA->report(new log('Unable to insert comment.', $ARGS['guestbook_comment']));
            return false;
          } else {
            return true;
          }
         break;

# END auto-generated Event-handlers

         default:
           $YANA->setVar('DATABASE', $this->database->source);
           return true;
         break;

     } # end switch

     return true;

  }

# BEGIN auto-generated functions

  function _get_table($ARGS, $table) {
    global $YANA;

    @settype($table,            "string");
    @settype($ARGS['where'],    "string");
    @settype($ARGS['sort'],     "string");
    @settype($ARGS['page'],     "integer");
    @settype($ARGS['entries'],  "integer");

    # set up vars
    $table       = strtolower($table);
    $primary_key = "";
    if (isset($ARGS['desc'])) {
      @settype($ARGS['desc'],   "boolean");
      $desc      = ($ARGS['desc']) ? true : false;
    } else {
      $desc      = true;
    }
    $page        = ($ARGS['page']<0) ? 0 : $ARGS['page'];
    $entPerPage  = $ARGS['entries'];
    if ($entPerPage<1)
    $entPerPage  = $YANA->getVar("PROFILE.GUESTBOOK.ENTPERPAGE");
    if ($entPerPage<1)
    $entPerPage  = 10;
    $primary_key = $this->database->source['TABLES'][$table]['PRIMARY_KEY'];
    $sortBy      = ($ARGS['sort']) ? $ARGS['sort'] : $primary_key;

    $result      = $this->database->get($table, $ARGS['where'], "ORDER BY ".$sortBy.(($desc)? ' DESC' : ''), $page, $entPerPage);

    $YANA->setVar('TABLE',       $table);
    $YANA->setVar('PRIMARY_KEY', $primary_key);
    $last_page = $this->database->length($table, $ARGS['where']);
    $YANA->setVar('LAST_PAGE', $last_page);
    $YANA->setVar('SORT', $sortBy);
    $YANA->setVar('WHERE', $ARGS['where']);
    $liste = array();
    if ($last_page > ($entPerPage*2)) {
      $dots = false;
      for($k=0;$k<ceil($last_page/$entPerPage);$k++) {
        $it   = count($liste);
        $first = ($k*$entPerPage);
        $last  = ((($k+1)*$entPerPage < $last_page) ? ($k+1)*$entPerPage : $last_page);
        if ($last_page > 10 * $entPerPage && $k > 1 && $k < ceil($last_page/$entPerPage) - 2 && !($first > $page-$entPerPage-1 && $last < $page+1+(2*$entPerPage))) {
          if (!$dots) {
            $dots = true;
            $liste[$it]['TOO_MANY'] = true;
          }
        } else {
          $liste[$it]['FIRST'] = ($first+1);
          $liste[$it]['LAST']  = $last;
          if ($first > $page-1 && $last < $page+$entPerPage+1) $dots = false;
        }
      }
    }
    $YANA->setVar('LIST_OF_ENTRIES', $liste);
    $YANA->setVar('ENTRIES_PER_PAGE', $entPerPage);
    $YANA->setVar('DESC', $desc);
    $YANA->setVar('FIRST_PAGE', $page+1);
    $YANA->setVar('OFFSET_PAGE', (($page+$entPerPage>$last_page) ? $last_page : $page+$entPerPage));
    return $result;
  }

# END auto-generated functions

   function _securityCheck() {

      global $YANA;

      # <... neue Gstebcher nicht anzeigen, falls Auto-Option deaktiviert ist
      $id   = $YANA->getVar('ID');
      if ($id=="default" || empty($id)) return false;
      $dir  = $YANA->registry->get('PROFILEDIR');
      $file = new inputStream($dir->getFilename().$YANA->getVar('ID').'cfg');
      if (!$file->exists() && !$YANA->getVar("PROFILE.AUTO")) {
        $YANA->report(new log('Access restriction in effect. Access to undefined profile '.$id.' denied.'));
        $YANA->report(new error('4041'));
        return false;
      }
      # ...>     
   }

   function _send_mail($empfaenger,$template,$INPUT) {
      global $YANA;
      $INPUT = changeCaseArray($INPUT);
      $heute                = getdate();
      $mail                 = new mailer($template);
      $mail->subject        = $YANA->getVar("LANGUAGE.MAIL_SUBJECT");
      $mail->insert("*", $INPUT);
      $mail->insert("*", $YANA->getVar("*"));
      $mail->insert('DATUM', $heute['mday'] . '.' . $heute['mon'] . '.' . $heute['year']);
      $mail->send($empfaenger);
   }

}

//  2006, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!

?>