<?php

/* public */ class user_security extends serializeableObject {

  /* private sessionManager */ var $sessionManager;
  /* private String */         var $user_name = "";

/*********************************************************************************************/

   /* constructor */ function user_security(/* String */ $file) {
      global $YANA;

      if (!empty($_SESSION['user_name'])) {
        $this->user_name = $_SESSION['user_name'];
        $YANA->setVar("SESSION_USER_ID", $this->user_name);
      }
      $this->sessionManager = new sessionManager($file);
      $YANA->setVar("SESSION_ID", session_id());
      $YANA->setVar("SESSION_NAME", session_name());
   }


  /* public boolean */ function set_pwd(/* String */ $pwt_alt, /* String */ $pwt_neu) {
    settype($pwt_alt,"string");
    settype($pwt_neu,"string");
    global $YANA;

    if (!$this->sessionManager->checkLogin($this->user_name,$pwt_alt)) {
     $YANA->message("error", "LOGIN_UNGUELTIG", "");
     return false;
    }
    if (!$this->sessionManager->changePwd($this->user_name,$pwt_neu)) {
     $YANA->message("error", "500", "index");
     return false;
    } else {
     $YANA->message("OK", "200", "index");
     return false;
    }
  }

  /* public boolean */ function get_login(/* Hashtable */ $ARGS) {
    settype($ARGS, "array");
    
    global $YANA;
    $form_params = (
                     (!empty($ARGS['target'])) ? '<input type="hidden" name="target" value="'.$ARGS['target'].'">'."\n" : ''
                   ).(
                     (!empty($ARGS['id']))     ? '<input type="hidden" name="id" value="'.$ARGS['id'].'">'."\n" : ''
                   ).
                   '<input type="hidden" name="action" value="check_login">'."\n".
                   '<input type="hidden" name="'.session_name().'" value="'.session_id().'">'."\n";
    $YANA->setVar("FORM_PARAMS", $form_params);
    return false;
  }

  /* public boolean */ function get_logout() {
    global $YANA;
    $this->sessionManager->logout();
    $YANA->message("OK", "LOGOUT", "");
    return false;
  }

  /* public boolean */ function login(/* String */ $nutzername, /* String */ $passwort) {
    settype($nutzername, "string");
    settype($passwort, "string");

    global $YANA;
    if ($this->sessionManager->login($nutzername,$passwort)) {
      $USER = $this->sessionManager->getUser($nutzername);
      settype($USER['COUNT_LOGINS'], "integer");
      $this->sessionManager->insertUser($nutzername, array("LAST_LOGIN" => time(), "COUNT_LOGINS" => $USER['COUNT_LOGINS'] +1));
      $YANA->message("OK", "LOGIN_OKAY");
    } else {
      $YANA->message("error", "LOGIN_UNGUELTIG");
    }
    return false;
  }

  /* public boolean */ function set_pluginlist(/* Hashtable */ $ARGS, /* String */ $event) {
    settype($ARGS, "array");
    settype($event, "string");

    global $YANA;

    if ($this->checkPermission($this->user_name,$ARGS['id'],$event)) {
      # access granted

      foreach ($_POST as $a => $b) {
        settype($b, "boolean"); 
        if ($b == 1 || $b == 0) {
          $YANA->plugins->setActive($a,$b);
        }
      }

      if (!$YANA->plugins->write()) {
        return false;
      } else {
        return true;
      }
    }
  }

  /* public boolean */ function check_login(/* Hashtable */ $ARGS, /* String */ $event) {
    settype($ARGS, "array");
    settype($event, "string");

    if (!empty($ARGS['id'])) $id = $ARGS['id'];
    else                     $id = "";

    global $YANA;

    if ($this->checkPermission($this->user_name,$id,$event)) {
      # access granted
      $YANA->setVar("PERMISSION",$this->sessionManager->getUserPermission($this->user_name,$id));
      return true;
    } else {
      return false;
    }
  }

/**********************************************************************************************
* Hilfsfunktionen
**********************************************************************************************/

  /* private boolean*/ function checkPermission(/* String */ $user_name,/* String */ $id, /* String */ $event) {

    settype($user_name, "string");
    settype($id, "string");
    settype($event, "string");
    global $YANA;
    $user_name = strtoupper($user_name);

    $required_perm = $YANA->plugins->getVar("*", "INTERFACE.$event.PERMISSION");
    $user_perm     = $this->sessionManager->getUserPermission($user_name,$id);
    settype($required_perm, "integer");
    settype($user_perm, "integer");
                                 
    if ($required_perm == 0 && $user_perm > -1) { // if no permission is required, then don't care for it

      return true;

    } else {

        if (!$this->sessionManager->isLoggedIn()) {
          $meldung = "403";
          $next_action = "login";
        } else {
          if ($required_perm <= $user_perm) return true;
          else {
            $meldung = "UNGENUEGENDE_RECHTE";
            $next_action = "";
          }
        }
        
        $YANA->setVar("TARGET", $event);
        $YANA->message("alert", $meldung, $next_action);
        return false;
        
    }
  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
